#!/usr/bin/ruby -w

pwb = Dir.pwd
begin
    Dir.chdir('/usr/lib/scotty-tng/daemon')
rescue
end

require 'drbd.rb'
require 'node.rb'
require 'notify.rb'
require 'sensor.rb'
require 'sensors/if.rb'
require 'sensors/rtt.rb'
require 'ringlist.rb'
require 'xml.rb'

begin
    Dir.chdir(pwd)
rescue
end


load("config/config.xml")

ScottyTNG.new

puts "\nStart monitoring...\n"

threads = []
threads << Thread.new {
    Sensors::RTT::monitor
}
threads << Thread.new {
    Sensors::IF::monitor
}

puts "\nRunning...\n"

threads.each{ |t| t.join }

puts "\nTerminated.\n"
