class DRingLD
  def initialize(ts, name)
    @ts, @name = ts, name
  end

  def self.create(ts, name, options)
    result = new(ts, name)
    result.init(options)
    result
  end

  class << self
    alias_method :find, :new
  end

  def init(options)
    @ts.write [:DRingLVals, @name, nil]
    @ts.write [:DRingLOpts, @name, options]
  end

  def push(value)
    t = @ts.take [:DRingLVals, @name, nil]
    t[2] = value
    @ts.write t
  end
end
