require 'snmp'

class Node
  include DRbUndumped

  @@nodes = Hash.new

  attr_reader :name, :address, :sensors, :ringlists, :snmp

  def initialize(xmlnode)
    @name = xmlnode.attributes["name"]
    @address = xmlnode.attributes["address"]
    @ringlists = Hash.new

    c = REXML::XPath.first(xmlnode, "community/@value")
    c = REXML::XPath.first(xmlnode.root, "/config/defaults/community/@value") unless c

    if c then
	@snmp = SNMP::Manager.new(:Host => @address,
				  :Community => c.to_s,
				  :Timeout => 2,
				  :Retries => 2)
    end

    puts " " + name + " [" + address + "]"
    print "   "
    @sensors = Array.new
    xmlnode.elements.each("*") { |xmlsensor|
	next if xmlsensor.name == "community"
	sensor = Sensor.create(self, xmlsensor)
	if(sensor != nil)
	    print "#{sensor.name} "
	    @sensors.push(sensor)
	end
    }
    puts
    
    @@nodes[name] = self
  end

  def self.addNode(xmlnode)
    return Node.new(xmlnode)
  end

  def self.getNodes()
    return @@nodes
  end
end
