module Sensors

  class RTT < Sensor
    @@nodes = Hash.new()
    @@sensors = Hash.new();

    @cur_rtt = 0
    @cur_lr = 0

    def initialize(node, xmlsensor)
      super(node, xmlsensor, "rtt")
      @@nodes[node.address] = node
      @@sensors[node.address] = self
	  

      RingList.new(node, self, "rtt" , {
		     'lines' => 2,
		     'title' => 'RTT',
		     'max' => [0, 100],
		     'format' => ["t", "p"],
		     'type' => ["v", "v"],
		     'color' => ["Green", "Red"],
		     'legend' => ["RTT", "Lossed"],
		     'slegend' => ["r", "l"],
		   })

      self.add_expr("rtt") { @cur_rtt }
      self.add_expr("lr") { @cur_lr }
    end

    def addProbe(min, avg, max, lr)
      @cur_rtt = avg.to_i
      @cur_lr = lr.to_i

      self.check_mon
      @node.ringlists["rtt"].pushProbe([@cur_rtt, (@cur_lr == 0 ? nil : @cur_lr) ])
    end
	
    def self.monitor()
      fping = IO.popen('/usr/bin/fping -Q 5 -Al 2>&1', 'w+')
      
      @@nodes.each_key{ |naddr|
	fping.puts(naddr)
      }
      fping.close_write
      
      while line=fping.gets do
	m = line.match(/^([\d.]+)\s*: xmt\/rcv\/%loss = \d+\/\d+\/([\d.]+)%(.*)$/)
	
	next if(m == nil)
	
	host = m[1]
	loss = Integer(m[2])
	
	min = 0
	avg = 0
	max = 0
	
	if rtt=m[3].match(/([\d.]+)\/([\d.]+)\/([\d.]+)/)
	  min = rtt[1]
	  avg = rtt[2]
	  max = rtt[3]
	end
	
	@@sensors[host].addProbe(min, avg, max, loss)
      end
    end
  end
end
